<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>DB DRAWER</title>
    <link href="https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700,900|Material+Icons" rel="stylesheet"
          type="text/css">
    <link href="https://cdn.jsdelivr.net/npm/quasar@1.15.10/dist/quasar.min.css" rel="stylesheet" type="text/css">
    <link href="assets/css/VueDraggableResizable.css" rel="stylesheet" type="text/css">
    <link href="assets/css/app.css" rel="stylesheet" type="text/css">
</head>
<body>
<div id="db-drawer">
    <div class="q-pa-md">
        <div class="row">
            <div class="col-12">
                <q-btn round color="black" icon="table_chart" @click="addTable"></q-btn>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-9 q-pa-md">
            <div class="tables">
                <vue-draggable-resizable
                        v-for="(table, index) in tables"
                        :parent="true"
                        :w="120"
                        :h="table.data.length * 28 + 26"
                        :x="table.x"
                        :y="table.y"
                        :resizable="false"
                        :lock-aspect-ratio="false"
                        @dragstop="onDrag"
                        :on-drag="onDragEvent"
                        @activated="onActivate(index)"
                        :min-height="28"
                        drag-cancel=".add-relation">
                    <q-table
                            :data="table.data"
                            :title="table.title"
                            :columns="columns"
                            hide-header
                            hide-bottom
                            dense
                            row-key="name"
                            :rows-per-page-options="[0]"
                            :class="currentTable === index && selectedTable ? 'selected' : ''"
                            title-class="q-table-title"
                    >
                        <template v-slot:body="props">
                            <q-tr v-if="typeof props.row !== 'undefined'" :props="props" @click="showSettings(index, props.row.id)" :class="typeof tables[currentTable].data[currentColumn] !== 'undefined' && tables[currentTable].data[currentColumn].id === props.row.id ? 'selected' : ''">
                                <q-td key="name" :props="props">
                                    {{ props.row.name }}
                                </q-td>
                            </q-tr>
                        </template>
                    </q-table>
                    <div class="add-relation has-many" @click="initRelation(index)"></div>
                    <div class="add-relation belong-to" @click="initRelation(index)"></div>
                    <div v-for="(relation, relationIndex) in table.relations"
                         :class="selectedRelation.length > 0 && selectedRelation[0] === index && selectedRelation[1] === relationIndex ? relation.classes + ' relation selected' : relation.classes + ' relation'"
                         @click="selectedRelation = [index, relationIndex]"
                         v-bind:style="{top: relation.t, bottom: relation.b, left: relation.l, right: relation.r, width: relation.w, height: relation.h}">
                    </div>
                </vue-draggable-resizable>
            </div>
        </div>
        <div class="col-3 q-pa-md">

            <div class="table-settings" v-if="typeof tables[currentTable] !== 'undefined' && typeof tables[currentTable].data[currentColumn] !== 'undefined'">
                <h3 v-html="tables[currentTable].title + ' settings'"></h3>
                <div class="q-pa-sm">
                    <q-input v-model="tables[currentTable].data[currentColumn].name" label="Column Name" placeholder="Column name" />
                </div>
                <div class="q-gutter-sm">
                    <q-btn color="primary" label="Add Column" size="sm" @click="addColumn()" ></q-btn>
                    <q-btn color="primary" label="remove Column" size="sm" @click="removeColumn()" ></q-btn>
                </div>
                <div class="q-pa-sm">
                    <q-select v-model="tables[currentTable].data[currentColumn].type" :options="columnTypes" label="Column type" />
                </div>
                <div class="q-pa-sm">
                    <q-checkbox v-model="tables[currentTable].data[currentColumn].pk" label="PRIMARY KEY" @input="changePK" />
                </div>
                <div class="q-pa-sm">
                    <q-checkbox v-model="tables[currentTable].data[currentColumn].ai" label="AUTO INCREMENT"/>
                </div>
                <div class="q-pa-sm">
                    <q-checkbox v-model="tables[currentTable].data[currentColumn].nn" label="NOT NULL"/>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
<script src="assets/js/VueDraggableResizable.umd.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/quasar@1.15.10/dist/quasar.umd.min.js"></script>
<script src="assets/js/app.js"></script>
</body>
</html>